#import "Bank.h"

@implementation Bank
-(id) init
{
	self = [super init];
	if(self != nil){
		bankContainer = [[NSMutableArray alloc] init];		
		if(bankContainer == nil){
			[self autorelease];
			self = nil;
		}
	}
	return self;
}

-(void) addToBank: (Account *) theAccount
{
	[bankContainer addObject: theAccount];
	
}

-(void) removeAcc: (Account *) theAccount
{
	[bankContainer removeObjectIdenticalTo: theAccount];
}


-(Account *) lookup: (NSString *) theName
{
	int i;
	for(i=0; i<[bankContainer count]; i++){
		if([[[bankContainer objectAtIndex: i] accName] caseInsensitiveCompare: theName] == NSOrderedSame)
			return [bankContainer objectAtIndex: i];
	}
	return nil;
}


-(void) printAllEntries
{
	int i;
	printf("%i customers:\n", [bankContainer count]);
	for(i=0; i<[bankContainer count]; i++){
		[[bankContainer objectAtIndex: i] print];
	}
}

-(void) sort
{
	[bankContainer sortUsingSelector: @selector(compareNames:)];
}

-(void) encodeWithCoder: (NSCoder *) encoder
{
	[encoder encodeObject: bankContainer];
}

-(id) initWithCoder: (NSCoder *) decoder
{
	bankContainer = [[decoder decodeObject] retain];
	return self;
}

-(NSMutableArray *) bankContainer
{
	return bankContainer;
}

-(void) dealloc {
	printf("bank deallocating...\n");
	[Bank dealloc];
	[super dealloc];
}

@end
